package com.example.nmgggzyspyder.es;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import org.springframework.util.ObjectUtils;

import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.Date;

@Data
public class HyZc {
    @JsonProperty("docid")
    private Long docid;

    @JsonProperty("docchannel")
    private Integer []docchannel;

    @JsonProperty("chnid")
    private Integer chnid;

    @JsonProperty("dockind")
    private Integer dockind;


    @JsonProperty("chnldesc")
    private String chnldesc;

    @JsonProperty("zc_doctitle")
    private String zc_doctitle;

    @JsonProperty("title")
    private String title;

    @JsonProperty("zc_docabstract")
    private String zc_docabstract;

    @JsonProperty("zc_doccontent")
    private String zc_doccontent;

    @JsonProperty("IdxId")
    private String IdxId;//索引号

    @JsonProperty("docno")
    private String docno;//文号

    @JsonProperty("publisher")
    private String publisher;//发布机构

    @JsonProperty("validity")
    private String validity;//有效期

    @JsonProperty("cdesc")
    private String cdesc;//主题分类

    @JsonProperty("docnotype")
    private String docnotype;//文号分类

    @JsonProperty("zupeitype")
    private String zupeitype;//组配分类

    @JsonProperty("wenzhongtype")
    private String wenzhongtype;//文种分类

    @JsonProperty("docpubtime")
    private String docpubtime;//无 = null

    @JsonProperty("opertime")
    private String opertime;//无 = null

    @JsonProperty("scrq")
    private String scrq;//成文日期

    @JsonProperty("year")
    private String year;

    @JsonProperty("month")
    private String month;

    @JsonProperty("docpuburl")
    private String docpuburl;

    @JsonProperty("siteid")
    private Integer siteid;

    @JsonProperty("sitedesc")
    private String sitedesc;

    @JsonProperty("docstatus")
    private Integer docstatus;

    @JsonProperty("docType")
    private Integer docType;//20

    @JsonProperty("recid")
    private Long recid;//0

    @JsonProperty("docStringId")
    private String docStringId;//通辽市专用，储存原本的stringid

    @JsonProperty("cityname")
    private String cityname;

    @JsonProperty("glcode")
    private String glcode;

    @JsonProperty("gltype")
    private String gltype;

    @JsonProperty("citylevel")
    private String citylevel="";
    //我要找政策
    @JsonProperty("perPolicyMyis")
    private String [] perPolicyMyis;

    @JsonProperty("perPolicyMyfind")
    private String [] perPolicyMyfind;

    @JsonProperty("orgPolicyMyis")
    private String [] orgPolicyMyis;

    @JsonProperty("orgPolicyMyfind")
    private String [] orgPolicyMyfind;

    public HyZc() {
    }
    public HyZc(HyZcMysqlModel hyZcMysqlModel,Integer channelid,Integer siteid,String fbjg,String sitedesc) {
        String manuscriptId = hyZcMysqlModel.getManuscriptId();
        String seq_num = hyZcMysqlModel.getSeqnum();
        String publishedTime1 = hyZcMysqlModel.getPublishedTime();
        System.out.println(seq_num);
        if(!ObjectUtils.isEmpty(seq_num)){
            try {
                this.docid = Long.parseLong(seq_num);
                this.recid = Long.parseLong(seq_num);
            }catch (Exception e){
                e.printStackTrace();
            }

        }
        String title = hyZcMysqlModel.getTitle();
        if(!ObjectUtils.isEmpty(title)){
            this.title = title;
            this.zc_doctitle = title;
        }
        String c_syh = hyZcMysqlModel.getCsyh();
        if(!ObjectUtils.isEmpty(c_syh)){
            this.IdxId = c_syh;
        }
        String c_wjbh = hyZcMysqlModel.getCwjbh();
        if(!ObjectUtils.isEmpty(c_wjbh)){
            this.docno = c_wjbh;
        }
        String c_gksx = hyZcMysqlModel.getCgksx();
        if(!ObjectUtils.isEmpty(c_gksx)){
            this.validity = c_gksx;
        }
        String newUrl = hyZcMysqlModel.getNewUrl();
        if(!ObjectUtils.isEmpty(newUrl)){
            this.docpuburl = newUrl;
        }
        String htmlContent = hyZcMysqlModel.getHtmlContent();
        if(!ObjectUtils.isEmpty(htmlContent)){
            this.zc_doccontent = htmlContent;
        }

        String publishedTime = hyZcMysqlModel.getPublishedTime();
        if(!ObjectUtils.isEmpty(publishedTime)){
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            long pubtime = Long.parseLong(publishedTime);
            Date date1 = new Date(pubtime);
            try {
                LocalDateTime localDateTime = date1.toInstant().atZone(ZoneId.systemDefault()).toLocalDateTime();
                LocalDateTime after8Hours = localDateTime.plusHours(8);
                date1 = Date.from(after8Hours.atZone(ZoneId.systemDefault()).toInstant());
            }catch (Exception e){
            }
            String pubtimeStr = simpleDateFormat.format(date1);
            this.scrq = pubtimeStr;
        }
        String modifiedTime = hyZcMysqlModel.getModifiedTime();
        if(!ObjectUtils.isEmpty(modifiedTime)){
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            long crtime = Long.parseLong(modifiedTime);
            Date date1 = new Date(crtime);
            String crtimeStr = simpleDateFormat.format(date1);
        }
        String c_fwrq = hyZcMysqlModel.getCfwrq();
        if(!ObjectUtils.isEmpty(c_fwrq)){
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            long crtime = Long.parseLong(c_fwrq);
            Date date1 = new Date(crtime);
            String crtimeStr = simpleDateFormat.format(date1);
            this.docpubtime = crtimeStr;
        }
        if(!ObjectUtils.isEmpty(siteid)){
            this.siteid = siteid;
        }
        if(!ObjectUtils.isEmpty(channelid)){
            this.docchannel = new Integer[]{channelid};
            this.chnid = channelid;
        }
        if(!ObjectUtils.isEmpty(fbjg)){
            this.publisher = fbjg;
        }
        this.sitedesc = sitedesc;
        this.dockind = 2;
        this.docstatus = 10;
    }
}
