package com.example.nmgggzyspyder.spyder;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.AlsMallbox;
import com.example.nmgggzyspyder.entity.TlsMallbox;
import com.example.nmgggzyspyder.service.AlsMallboxService;
import com.example.nmgggzyspyder.service.TlsMallboxService;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.HttpResponse;
import kong.unirest.JsonNode;
import kong.unirest.Unirest;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class MallBoxALSrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private AlsMallboxService alsMallboxService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";



    public void zyxx(){

        try {
            HttpResponse<JsonNode> response =   Unirest.post("http://www.alsggzyjy.cn/PublicServer/complaint/listComplaintAndObjections.do")
                        .header("accept", "application/json")
                        .queryString("page", "1")
                        .queryString("rows", "10")
                        .queryString("complaintsType", "1")
                        .asJson();
            JsonNode body = response.getBody();
            String sStr = body.toString();
            System.out.println(sStr);
            JSONObject jsonObj = JSON.parseObject(sStr);
            Object listData = jsonObj.get("data");
            JSONArray parseArray = JSON.parseArray(String.valueOf(listData));
            for (Object o : parseArray) {
                JSONObject jsonObject = JSON.parseObject(o.toString());
                System.out.println(jsonObject);
                String id = jsonObject.get("id").toString();
                AlsMallbox alsMallbox = new AlsMallbox();
                if(!ObjectUtils.isEmpty(id)){
                    String url = "http://www.alsggzyjy.cn/PublicServer/public/dissentAndComplain/showDetail.html?complaintsType="+id;
                    if(!ObjectUtils.isEmpty(jsonObject.get("complaintDate"))){
                        String complaintDate = jsonObject.get("complaintDate").toString();
                        alsMallbox.setPetitionerTime(complaintDate);
                    }
                    if(!ObjectUtils.isEmpty(jsonObject.get("complaintName"))){
                        String complaintName = jsonObject.get("complaintName").toString();
                        alsMallbox.setPetitionerName(complaintName);
                    }
                    if(!ObjectUtils.isEmpty(jsonObject.get("complaintContent"))){
                        String complaintContent = jsonObject.get("complaintContent").toString();
                        alsMallbox.setPetitionerContent(complaintContent);
                    }
                    if(!ObjectUtils.isEmpty(jsonObject.get("handleResult"))){
                        String handleResult = jsonObject.get("handleResult").toString();
                        alsMallbox.setReplyContent(handleResult);
                    }
                    if(!ObjectUtils.isEmpty(jsonObject.get("handleDate"))){
                        String handleDate = jsonObject.get("handleDate").toString();
                        alsMallbox.setReplyTime(handleDate);
                    }
                    if(!ObjectUtils.isEmpty(jsonObject.get("lastUpdateUser"))){
                        String lastUpdateUser = jsonObject.get("lastUpdateUser").toString();
                        alsMallbox.setReplyUnit(lastUpdateUser);
                    }
                    if(!ObjectUtils.isEmpty(jsonObject.get("complaintTitle"))){
                        String complaintTitle = jsonObject.get("complaintTitle").toString();
                        alsMallbox.setTitle(complaintTitle);
                    }
                    alsMallbox.setId(id);
                    alsMallbox.setUrl(url);
                    alsMallbox.setChannle("异议");
                    String isShow = jsonObject.get("isShow").toString();
                    System.out.println(alsMallbox);
                    alsMallboxService.saveOrUpdate(alsMallbox);

                    saveContent(url);
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    public void saveContent(String url){
        QueryWrapper<AlsMallbox> queryWrapper = new QueryWrapper<AlsMallbox>();
        queryWrapper.eq("url", url);
        List<AlsMallbox> list = alsMallboxService.list(queryWrapper);
        for (AlsMallbox alsMallbox : list) {
            zyxxCont(alsMallbox);
        }
    }

    public void zyxxCont(AlsMallbox alsMallbox){
        try {

            try {
                HttpResponse<JsonNode> response = Unirest.post("http://www.alsggzyjy.cn/PublicServer/supervisionAttachment/list.do")
                        .header("accept", "application/json")
                        .queryString("complaintHandle", "0")
                        .queryString("attachmentSetCode", alsMallbox.getId())
                        .asJson();
                JsonNode body = response.getBody();
                String sStr = body.toString();
                System.out.println(sStr);
                JSONObject jsonObj = JSON.parseObject(sStr);
                Object listData = jsonObj.get("data");
                JSONArray parseArray = JSON.parseArray(String.valueOf(listData));
                String fileName = "";
                for (Object o : parseArray) {
                    String urldow = "http://www.alsggzyjy.cn/doFile/download/?attachmentId=";
                    JSONObject jsonObject = JSON.parseObject(o.toString());
                    String attachmentType = jsonObject.get("attachmentType").toString();
                    String url = jsonObject.get("url").toString();
                    urldow = urldow + url;
                    String attachmentFileName = jsonObject.get("attachmentFileName").toString();
                    String fileType = getFileType(attachmentFileName);
                    String md5id = DigestUtils.md5DigestAsHex(urldow.getBytes());
                    fileName = fileName + downLoadFromUrl(urldow,md5id+"."+fileType,"D:/ruoyi/a/") +",";
                }
                alsMallbox.setPetitionerFile(fileName);
            }catch (Exception e){
            }

            try {
                HttpResponse<JsonNode> response = Unirest.post("http://www.alsggzyjy.cn/PublicServer/supervisionAttachment/list.do")
                        .header("accept", "application/json")
                        .queryString("complaintHandle", "1")
                        .queryString("attachmentSetCode", alsMallbox.getId())
                        .asJson();
                JsonNode body = response.getBody();
                String sStr = body.toString();
                System.out.println(sStr);
                JSONObject jsonObj = JSON.parseObject(sStr);
                Object listData = jsonObj.get("data");
                JSONArray parseArray = JSON.parseArray(String.valueOf(listData));
                String fileName = "";
                for (Object o : parseArray) {
                    String urldow = "http://www.alsggzyjy.cn/doFile/download/?attachmentId=";
                    JSONObject jsonObject = JSON.parseObject(o.toString());
                    String attachmentType = jsonObject.get("attachmentType").toString();
                    String url = jsonObject.get("url").toString();
                    urldow = urldow + url;
                    String attachmentFileName = jsonObject.get("attachmentFileName").toString();
                    String md5id = DigestUtils.md5DigestAsHex(urldow.getBytes());
                    String fileType = getFileType(attachmentFileName);
                    fileName = fileName + downLoadFromUrl("urldow",md5id+"."+fileType,"D:/ruoyi/a/") +",";
                }
                alsMallbox.setReplyFile(fileName);
            }catch (Exception e){
            }
            alsMallboxService.updateById(alsMallbox);

        }catch (Exception e){
        }
    }

    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                e.printStackTrace();
                return fileName;
            }
        }
        return fileName;
    }



}
